#include <iostream>
#include <vector>

using namespace std;

//finds the first window seat availible, claims it, and returns the row.
//Returns seat_taken.size() if all windows are filled
int seat_window(vector <vector<bool> >& seat_taken){
  for(int i = 0; i < seat_taken.size(); i++){
    if(!seat_taken[i][0]){
      seat_taken[i][0] = true;
      return i;
    }
  }
  return seat_taken.size();
}

//same idea, with aisle seat
int seat_aisle(vector <vector<bool> >& seat_taken){
  for(int i = 0; i < seat_taken.size(); i++){
    if(!seat_taken[i][2]){
      seat_taken[i][2] = true;
      return i;
    }
  }
  return seat_taken.size();
}
  
//same idea, with middle seat
int seat_middle(vector <vector<bool> >& seat_taken){
  for(int i = 0; i < seat_taken.size(); i++){
    if(!seat_taken[i][1]){
      seat_taken[i][1] = true;
      return i;
    }
  }
  return seat_taken.size();
}

//seats a group of "group_size" people
void seat_group(vector <vector<bool> >& seat_taken, int group_size){
  //empty_row[i] holds the first row with i empty seats
  vector<int> empty_row(4,seat_taken.size());
  for(int i = 0; i < seat_taken.size(); i++){
    int num_empty = 0;
    for(int j = 0; j < 3; j++)
      if(!seat_taken[i][j])
	num_empty++;
    if(num_empty > 0 && i < empty_row[1])
      empty_row[1] = i;
    if(num_empty > 1 && i < empty_row[2])
      empty_row[2] = i;
    if(num_empty > 2 && i < empty_row[3])
      empty_row[3] = i;
  }
  int start_row;
  if(empty_row[3] < seat_taken.size())
    start_row = empty_row[3];
  else if(empty_row[2] < seat_taken.size())
    start_row = empty_row[2];
  else 
    start_row = empty_row[1];
  int start_col = 0;
  while(group_size > 0){
    if(!seat_taken[start_row][start_col]){
      seat_taken[start_row][start_col] = true;
      group_size--;
    }
    start_col++;
    if(start_col == 3){
      start_col = 0;
      start_row++;
    }
  }
}
  
int main(){
  int n,r;
  cin >> r;
  while(r > 0){
    cin >> n;
    vector<vector<bool> > seat_taken(r);
    for(int i = 0; i < r; i++){
      seat_taken[i].resize(3,false);
    }
    vector<char> passengers(n);
    for(int i = 0; i < n; i++){
      cin >> passengers[i];
    }
    //now, for each passenger..
    for(int i = 0; i < n; i++){
      if(passengers[i] == 'A'){
	if(seat_aisle(seat_taken) == r)
	  if(seat_window(seat_taken) == r)
	    seat_middle(seat_taken);
      }
      else if(passengers[i] == 'W'){
	if(seat_window(seat_taken) == r)
	  if(seat_aisle(seat_taken) == r)
	    seat_middle(seat_taken);
      }
      else {
	int group_size = 0;
	while(passengers[i] == 'G' && i < n){
	  i++;
	  group_size++;
	}
	i--; // back to the last person in the group
	seat_group(seat_taken, group_size);
      }
    }
    //now, seat the user
    int my_seat = min( seat_window(seat_taken), seat_aisle(seat_taken));
    if(my_seat != r){
      cout << "Non-middle seat found in row " << my_seat+1 << "." << endl;
    }
    else{
      cout << "Forced into middle seat in row " << seat_middle(seat_taken)+1
	   << "." << endl;
    }
    cin >> r;
  }
  return 0;
}
