#include <iostream>
#include <vector>

using namespace std;

int find_loop(const vector<int> & Board, vector<bool>& visited, int cur_space){
  while(!visited[cur_space] && Board[cur_space] != 0){
    visited[cur_space] = true;
    cur_space = (cur_space + Board[cur_space]);
    if(cur_space < 0)
      cur_space = cur_space + Board.size();
    if(cur_space >= Board.size())
      cur_space = cur_space - Board.size();
   
  }
  if(visited[cur_space]){ // now to find where the loop starts
    int early_space = cur_space;
    int start_space = cur_space;
    //  cout << "Loop: " << cur_space; 
    cur_space = (cur_space + Board[cur_space]);
    
    if(cur_space < 0)
      cur_space = cur_space + Board.size();
    if(cur_space >= Board.size())
      cur_space = cur_space - Board.size();
    
    while(cur_space != start_space){
      //    cout << " " << cur_space;
      if(cur_space < early_space)
	early_space = cur_space;
      cur_space = (cur_space + Board[cur_space]);
      if(cur_space < 0)
	cur_space = cur_space + Board.size();
      if(cur_space >= Board.size())
	cur_space = cur_space - Board.size();

    }
    //  cout << endl;
    return early_space;
  }
  else
    return -1;
}


void Print_Loop(const vector<int>& Board, int start){
  cout << start << " ";
  int cur_space = (start + Board[start]);
    
  if(cur_space < 0)
      cur_space = cur_space + Board.size();
  if(cur_space >= Board.size())
    cur_space = cur_space - Board.size();
  while(cur_space != start){
    cout << cur_space << " ";
    cur_space = (cur_space + Board[cur_space]);
    
    if(cur_space < 0)
      cur_space = cur_space + Board.size();
    if(cur_space >= Board.size())
      cur_space = cur_space - Board.size();
  }
}
int main(){
  int n;
  cin >> n;
  int cur_board = 1;
  while(n > 0){
    vector<int> Board(n);
    for(int i = 0; i < n; i++){
      cin >> Board[i];
    }
    //now, try each space.  Not very efficient because we find the same loop
    // several times, but that's only 100^2 steps at most.
    cout << endl << endl;
    Print_Loop(Board, 19);
    int loop_location = n+1;
    for(int i = 0; i < n; i++){
      vector<bool> visited(n, false);
     
      int this_loop_start = find_loop(Board, visited, i);
      if(this_loop_start != -1)
	if(this_loop_start < loop_location)
	  loop_location = this_loop_start;
      
     
    }
  cout << "Board " <<cur_board << ": ";
    if(loop_location == n+1) {
      cout << "No loop found." << endl;
    }
    else{
      Print_Loop(Board, loop_location);
      cout << "Loop begins at space " << loop_location+1 << "." << endl;
    }

    cur_board++;
    cin >> n;
  }
  return 0;
}
