#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
struct point{
  double x;
  double y;
};
struct line{
  point start;
  point end;
};

double my_distance(point p1, point p2){
  return sqrt(pow(p1.x-p2.x,2) + pow(p1.y-p2.y,2));
}
int find_most_interesting_toy_in_range(const vector<point>& toys, int range, point baby_position){
  int best_toy = -1;
  for(int i = 0; i < toys.size(); i++){
    if(my_distance(toys[i], 
		baby_position) <= range)
      best_toy = i;
  }
  return best_toy;
}

point find_next_turn(const vector<point>& toys, int range, point baby_position, int& cur_toy){
  int new_toy = cur_toy;
  line cur_path;
  cur_path.start = baby_position;
  cur_path.end = toys[cur_toy];
  point next_step;
  if(cur_path.start.x == cur_path.end.x) { //test for infinite slope
    if(cur_path.start.y < cur_path.end.y){
      next_step.x = cur_path.start.x;
      next_step.y = min(cur_path.start.y+1, cur_path.end.y);
    }
    else{
      next_step.x = cur_path.start.x;
      next_step.y = max(cur_path.start.y-1, cur_path.end.y);
    }
  }
  else{ // get the slope
    double slope = (cur_path.end.y-cur_path.start.y)/(cur_path.end.x-cur_path.start.x);
    double dx = sqrt(1/(slope*slope+1));
    double dy = slope * dx;
    if(dy<0){
      dx=dx*-1;
      dy=dy*-1;
    }
    next_step.x = baby_position.x + dx;
    next_step.y = baby_position.y + dy;
    if(next_step.y > cur_path.end.y){
      next_step = cur_path.end;
    }
    //now that we have the next place to go, find the direction we want to turn
    // to now
  }
  for(int i = cur_toy+1; i < toys.size(); i++){
    if(my_distance (toys[i], next_step) <= range)
      cur_toy = i;
    }

  return next_step;
}
      
int main(){
  int c;
  cin >> c;
  for(int i = 0; i < c; i++){
    int r, t;
    cin >> r >> t;
    vector<point> toys (t);
    for(int j = 0; j < t; j++){
      cin >> toys[j].x >> toys[j].y;
    }
    point baby_position;
    baby_position.x = 0;
    baby_position.y = 0;
    int cur_toy = find_most_interesting_toy_in_range(toys,r,baby_position);
    //   cout << "baby_position: (" << baby_position.x << "," 
    //	   << baby_position.y << ")" << endl;
    point new_position = find_next_turn(toys,r,baby_position, cur_toy);
    while(new_position.x != baby_position.x ||
	  new_position.y != baby_position.y){
      baby_position = new_position;
      //     cout << "baby_position: (" << baby_position.x << "," 
      //	   << baby_position.y << ")" << endl;
      new_position = find_next_turn(toys,r,baby_position, cur_toy);
    }
    cout << "Case " << i+1 << ": The baby is playing with toy " << cur_toy +1
	 << "." << endl;
  }
  return 0;
}
      
