#include <iostream>
#include <vector>

using namespace std;
bool Find_Word_Rec(vector<vector<char> >& Grid, const string& key_word, 
		   int r, int c);

bool On_Grid(const vector<vector<char> >& Grid, int r, int c){
  if(r < 0 || c < 0)
    return false;
  if(r >= Grid.size() || c >= Grid[0].size())
    return false;
  return true;
}

bool Try_Direction(vector<vector<char> >& Grid, const string& key_word,
		   int new_r, int new_c){
  if(On_Grid(Grid, new_r, new_c) && Grid[new_r][new_c] == key_word[0]){
    char saved_letter = key_word[0];
    Grid[new_r][new_c] = '-';
    if(Find_Word_Rec(Grid, key_word, new_r, new_c))
      return true;
    else{
      Grid[new_r][new_c] = saved_letter;
      return false;
    }
  }
  else
    return false;
}
bool Find_Word_Rec(vector<vector<char> >& Grid, const string& key_word, 
		   int r, int c){
  if(key_word.size() == 1 || key_word.size() == 0)
    return true;
 
  else{
    //try all 8 directions
    int new_r, new_c;
    string new_key_word = key_word.substr(1,key_word.size()-1);
    if(Try_Direction(Grid, new_key_word, r+1,c+2) ||
       Try_Direction(Grid, new_key_word, r+2,c+1) ||
       Try_Direction(Grid, new_key_word, r-1,c-2) ||
       Try_Direction(Grid, new_key_word, r-2,c-1) ||
       Try_Direction(Grid, new_key_word, r+1,c-2) ||
       Try_Direction(Grid, new_key_word, r-2,c+1) ||
       Try_Direction(Grid, new_key_word, r-1,c+2) ||
       Try_Direction(Grid, new_key_word, r+2,c-1))
      return true;
    else
      return false;
  }
}
bool Find_Word(vector<vector<char > >& Grid, string key_word){
  if(key_word == "")
    return true;
  else{
    for(int i = 0; i < Grid.size(); i++)
      for(int j = 0; j < Grid[0].size(); j++)
	if(Grid[i][j] == key_word[0]){
	  Grid[i][j] = '-';
	  if(Find_Word_Rec(Grid, key_word,i,j))
	    return true;
	  else
	    Grid[i][j] = key_word[0];
	}
  }
  return false;
}
int main(){
  int r,c;
  cin >> r >> c;
  int cur_grid = 0;
  while(r != 0 && c != 0){
    cur_grid++;
    vector<vector<char> > Grid;
    Grid.resize(r);
    for(int i = 0; i < r; i++){
      Grid[i].resize(c);
      for(int j = 0; j < c; j++)
	cin >> Grid[i][j];
    }
    string key_word;
    cin >> key_word;
    if(Find_Word(Grid, key_word)){
      cout << "Grid " << cur_grid << ": Word found" << endl;
    }
    else
      cout << "Grid " << cur_grid << ": Word not found" << endl;
    
    cin >> r >> c;
  }
  return 0;
}
