#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int count_runs (const vector<bool> & hi_low_sequence){
  int num_runs = 1;
  bool cur_side = hi_low_sequence[0];
  for(int i = 1; i < hi_low_sequence.size(); i++){
    if(hi_low_sequence[i] != cur_side) //then we have a new run
      num_runs++;
    cur_side = hi_low_sequence[i];
  }
  return num_runs;
}
int main(){
  int k;
  cin >> k;
  int cur_sequence = 0;
  while(k > 0){
    cur_sequence++;
    vector<bool> hi_low_sequence(k); //don't store the numbers, just
    //their magnitude (high=true)
    int r;
    cin >> r;
    int n=0;
    int m = 0;
    for(int i = 0; i < k; i++){
      int next_val;
      cin >> next_val;
     
      if(next_val <= r/2){
	hi_low_sequence[i] = false;
	m++;
      }
      else{
	hi_low_sequence[i] = true;
	n++;
      }
    }
    int num_runs = count_runs(hi_low_sequence);
    //     cout << "num_runs: " << num_runs << endl;
    double first_part = 2*m*n/(double) k + 1;
    double radical = sqrt((2*m*n*(2*m*n-k))/(k*k*(k-1)));
    double low_bound = first_part -1.96*radical;
    //     cout << "low_bound: " << low_bound << endl;
    double high_bound = first_part+1.96*radical;
    //     cout << "high_bound: " << high_bound << endl;
    if(num_runs >= low_bound && num_runs <= high_bound){
      cout << "Sequence " << cur_sequence << ": Random" << endl;
    }
    else
      cout << "Sequence " << cur_sequence << ": Not Random" << endl;
    cin >> k;
  }
  return 0;
}
    
